Subject: Re: git push default behaviour?

From: Junio C Hamano <[email-masked]>
Date: Thu, 08 Mar 2012 10:22:43 -0800

Jeremy Morton <[email-masked]> writes:

> Obviously - but my point is that it needn't be so dangerous by
> default.  It tries to push all matching branches - is that really a
> more common requirement than pushing the current branch?

Depends on the way you work. If you publish to your own repository
and let others pull, the behaviour is not dangerous at all with or
without --force (well, --force brings its own danger but that does
not have anything to do with which branches are pushed).  If you
default to 'current' in such a workflow, you risk forgetting to
push, which is the more dangerous option between the two.

When using a single shared central repository to work with others,
current may be more appropriate, and that is why the behaviour is
configurable.